/* ftpq: add.c

Copyright (C) 2000, 2001 Mark Tranchant

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "ftpq.h"

int add_to_queue (char **argv) {

	pid_t mypid = 0;
	char filename[32];
	char cwd[256];
	FILE *queuefile = NULL;
	struct server *list_start = NULL;
	int jobid = 0;
	char *lfilename = NULL;
	struct stat lfiledet;
	int filectr = 0;

	mypid = getpid ();
	getcwd (cwd, 255);

	while (filectr < gv_lfilectr) {
		jobid = next_free_job ();
		if (argv[gv_lfileidx + filectr][0] == '/') {
			lfilename = memalloc (strlen (argv[gv_lfileidx + filectr] + 1));
			sprintf (lfilename, "%s", argv[gv_lfileidx + filectr]);
		}
		else {
			lfilename = memalloc (strlen (cwd) + strlen (argv[gv_lfileidx + filectr]) + 2);
			sprintf (lfilename, "%s/%s", cwd, argv[gv_lfileidx + filectr]);
		}
		sprintf (filename, "%s%d-%d-%d", SPOOLDIR, jobid, (int) getuid (), (int) mypid);

		if (stat (lfilename, &lfiledet) != 0) {
			printf ("ftpq: can't find local file %s!\n", lfilename);
		}
		else {
			if (S_ISREG (lfiledet.st_mode)) {
				queuefile = fileopen (filename, FO_WRITE, FO_NEED);

				fprintf (queuefile, "ftpq-%1.2f jobfile\n", VERSION);
				fprintf (queuefile, "Job:      %d\n", jobid);
				fprintf (queuefile, "User:     %d\n", (int) getuid ());
				fprintf (queuefile, "Host:     %s\n", gv_host);
				fprintf (queuefile, "Port:     %d\n", gv_port);
				fprintf (queuefile, "Login:    %s\n", gv_login);
				if (gv_passwd != NULL)
					fprintf (queuefile, "Password: %s\n", gv_passwd);
				if (gv_acct != NULL)
					fprintf (queuefile, "Account:  %s\n", gv_acct);
				if (gv_rdir != NULL)
					fprintf (queuefile, "RemDir:   %s\n", gv_rdir);
				if (gv_rfile != NULL)
					fprintf (queuefile, "RemFile:  %s\n", gv_rfile);
				else {
					if (argv[gv_lfileidx + filectr][0] == '/')
						fprintf (queuefile, "RemFile:  %s\n", &argv[gv_lfileidx + filectr][1]);
					else
						fprintf (queuefile, "RemFile:  %s\n", argv[gv_lfileidx + filectr]);
				}
				if (gv_copy == COPY) {
					make_copy (lfilename, jobid, (int) getuid (), (int) mypid);
					fprintf (queuefile, "LocDir:   %s\n", SPOOLDIR);
					fprintf (queuefile, "LocFile:  %d-%d-%d.snp\n", jobid, (int) getuid (), (int) mypid);
				}
				else if (argv[gv_lfileidx + filectr][0] == '/') {
					fprintf (queuefile, "LocDir:   /\n");
					fprintf (queuefile, "LocFile:  %s\n", &argv[gv_lfileidx + filectr][1]);
				}
				else {
					fprintf (queuefile, "LocDir:   %s\n", cwd);
					fprintf (queuefile, "LocFile:  %s\n", argv[gv_lfileidx + filectr]);
				}
				fprintf (queuefile, "JobFile:  %s\n", filename);
				fprintf (queuefile, "Size:     %ld\n", (long) lfiledet.st_size);
				fclose (queuefile);
				chmod (filename, S_IRUSR | S_IWUSR);
				printf ("ftpq: queued %s (%d)\n", lfilename, jobid);
			}
			else {
				printf ("ftpq: %s is not a file, skipping.\n", lfilename);
			}
		}

		free (lfilename);
		filectr++;
	}

	/* Rebuild list to sort and clear out any obsolete jobs */

	list_start = build_joblist ();
	free_joblist (list_start);

	return OK;

}
