/* ftpq: copy.c

Copyright (C) 2000, 2001 Mark Tranchant

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "ftpq.h"

int make_copy (char *filename, int jobid, int uid, int pid) {

	FILE *lfile = NULL;
	FILE *snpfile = NULL;
	char snpname[256];
	int tosend;
	long totalgone, bytesize, gone;
	struct stat filedet;

	stat (filename, &filedet);
	bytesize = (off_t) filedet.st_size;

	sprintf (snpname, "%s%d-%d-%d.snp", SPOOLDIR, jobid, uid, pid);
	lfile = fileopen (filename, FO_READ, FO_NEED);
	snpfile = fileopen (snpname, FO_WRITE, FO_NEED);

	totalgone = 0L;

	while (totalgone < bytesize) {
		tosend = fread (buffer, 1, BUFSIZE, lfile);
		gone = 0L;
		while (gone < tosend) {
			gone += fwrite (buffer, 1, tosend, snpfile);
			totalgone += gone;
		}
	}

	fclose (lfile);
	fclose (snpfile);

	chmod (snpname, S_IRUSR | S_IWUSR);

	return OK;
}
